'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _codemirror = require('codemirror');

var _codemirror2 = _interopRequireDefault(_codemirror);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ReactCodeMirror = function (_Component) {
  (0, _inherits3.default)(ReactCodeMirror, _Component);

  function ReactCodeMirror(props) {
    (0, _classCallCheck3.default)(this, ReactCodeMirror);

    var _this = (0, _possibleConstructorReturn3.default)(this, (ReactCodeMirror.__proto__ || (0, _getPrototypeOf2.default)(ReactCodeMirror)).call(this, props));

    _this.codemirror = null;
    _this.editor = null;
    return _this;
  }

  (0, _createClass3.default)(ReactCodeMirror, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      // 生成codemirror实例
      this.editor = _codemirror2.default.fromTextArea(this.textarea, this.props.options);
      // 获取CodeMirror用于获取其中的一些常量
      this.codemirror = _codemirror2.default;
      // 事件处理映射
      var eventDict = this.getEventHandleFromProps();

      (0, _keys2.default)(eventDict).forEach(function (event) {
        _this2.editor.on(eventDict[event], _this2.props[event]);
      });

      var _props = this.props,
          value = _props.value,
          width = _props.width,
          height = _props.height;
      // 初始化值

      this.editor.setValue(value || '');

      if (width || height) {
        // 设置尺寸
        this.editor.setSize(width, height);
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var val = this.editor.getValue();
      var next = nextProps.value;
      if (next !== undefined && next !== this.props.value && next !== val) {
        this.editor.setValue(nextProps.value);
      }
      var options = nextProps.options,
          width = nextProps.width,
          height = nextProps.height;

      this.setOptions(options);

      if (width !== this.props.width || height !== this.props.height) {
        this.editor.setSize(width, height);
      }
    }
    // http://codemirror.net/doc/manual.html#config

  }, {
    key: 'setOptions',
    value: function setOptions(options) {
      var _this3 = this;

      if ((typeof options === 'undefined' ? 'undefined' : (0, _typeof3.default)(options)) === 'object') {
        (0, _keys2.default)(options).forEach(function (name) {
          if ((0, _stringify2.default)(_this3.props.options[name]) !== (0, _stringify2.default)(options[name])) {
            _this3.editor.setOption(name, options[name]);
          }
        });
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.editor) {
        this.editor.toTextArea();
      }
    }

    // 将props中所有的事件处理函数映射并保存

  }, {
    key: 'getEventHandleFromProps',
    value: function getEventHandleFromProps() {
      var propNames = (0, _keys2.default)(this.props);
      var eventHandle = propNames.filter(function (prop) {
        return (/^on+/.test(prop)
        );
      });

      var eventDict = {};
      eventHandle.forEach(function (ele) {
        eventDict[ele] = ele.replace(/^on[A-Z]/g, function (s) {
          return s.slice(2).toLowerCase();
        });
      });

      return eventDict;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      return _react2.default.createElement('textarea', { ref: function ref(instance) {
          _this4.textarea = instance;
        } });
    }
  }]);
  return ReactCodeMirror;
}(_react.Component);

exports.default = ReactCodeMirror;


ReactCodeMirror.defaultProps = {
  value: '',
  options: {},
  width: null,
  height: null
};

ReactCodeMirror.propTypes = {
  value: _propTypes2.default.string,
  options: _propTypes2.default.object,
  width: function width(props, propName, componentName) {
    var width = props[propName];
    if (!(width === null || typeof width === 'number' || typeof width === 'string')) {
      return new Error('Invalid prop `' + propName + '` supplied to' + (' `' + componentName + '`. Validation failed.'));
    }
  },
  height: function height(props, propName, componentName) {
    var height = props[propName];
    if (!(height === null || typeof height === 'number' || typeof height === 'string')) {
      return new Error('Invalid prop `' + propName + '` supplied to' + (' `' + componentName + '`. Validation failed.'));
    }
  }
};