'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

require('codemirror/lib/codemirror.css');

var _CodeMirror = require('./CodeMirror');

var _CodeMirror2 = _interopRequireDefault(_CodeMirror);

var _loadMode = require('./loadMode');

var _loadMode2 = _interopRequireDefault(_loadMode);

require('./index.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ReactCodeMirror = function (_Component) {
  (0, _inherits3.default)(ReactCodeMirror, _Component);

  function ReactCodeMirror(props) {
    (0, _classCallCheck3.default)(this, ReactCodeMirror);

    var _this = (0, _possibleConstructorReturn3.default)(this, (ReactCodeMirror.__proto__ || (0, _getPrototypeOf2.default)(ReactCodeMirror)).call(this, props));

    _this.getInstance = function (instance) {
      if (instance) {
        _this.codemirror = instance.codemirror;
        _this.editor = instance.editor;
      }
    };

    _this.state = {
      codeMirrorOptions: {}
    };
    return _this;
  }

  (0, _createClass3.default)(ReactCodeMirror, [{
    key: 'componentDidMount',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var options, codeMirrorOptions;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                options = this.props.options;
                codeMirrorOptions = (0, _extends3.default)({
                  theme: 'eclipse',
                  tabSize: 2,
                  autoCloseBrackets: true,
                  matchBrackets: true,
                  showCursorWhenSelecting: true,
                  // 显示行号
                  lineNumbers: true,
                  fullScreen: true
                }, options);
                _context.next = 4;
                return (0, _loadMode2.default)(codeMirrorOptions.mode);

              case 4:
                this.setState({ codeMirrorOptions: codeMirrorOptions });

              case 5:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function componentDidMount() {
        return _ref.apply(this, arguments);
      }

      return componentDidMount;
    }()
  }, {
    key: 'componentWillReceiveProps',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(nextPros) {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!(nextPros.options && nextPros.options.mode !== this.props.options.mode)) {
                  _context2.next = 3;
                  break;
                }

                _context2.next = 3;
                return (0, _loadMode2.default)(nextPros.options.mode);

              case 3:
                this.setState({
                  codeMirrorOptions: (0, _extends3.default)({}, this.state.codeMirrorOptions, nextPros.options)
                });

              case 4:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function componentWillReceiveProps(_x) {
        return _ref2.apply(this, arguments);
      }

      return componentWillReceiveProps;
    }()
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          options = _props.options,
          otherProps = (0, _objectWithoutProperties3.default)(_props, ['options']);
      var codeMirrorOptions = this.state.codeMirrorOptions;

      return _react2.default.createElement(_CodeMirror2.default, (0, _extends3.default)({}, otherProps, {
        ref: this.getInstance,
        options: (0, _extends3.default)({}, codeMirrorOptions)
      }));
    }
  }]);
  return ReactCodeMirror;
}(_react.Component);

exports.default = ReactCodeMirror;